Index: issm/trunk-jpl/src/c/analyses/HydrologyDCInefficientAnalysis.cpp
===================================================================
--- issm/trunk-jpl/src/c/analyses/HydrologyDCInefficientAnalysis.cpp	(revision 25317)
+++ issm/trunk-jpl/src/c/analyses/HydrologyDCInefficientAnalysis.cpp	(revision 25379)
@@ -5,5 +5,5 @@
 #include "../shared/shared.h"
 #include "../modules/modules.h"
-#include "../classes/Inputs2/TransientInput2.h"
+#include "../classes/Inputs/TransientInput.h"
 
 /*Model processing*/
@@ -79,5 +79,5 @@
   iomodel->DeleteData(&requestedoutputs,numoutputs,"md.hydrology.requested_outputs");
 }/*}}}*/
-void HydrologyDCInefficientAnalysis::UpdateElements(Elements* elements,Inputs2* inputs2,IoModel* iomodel,int analysis_counter,int analysis_type){/*{{{*/
+void HydrologyDCInefficientAnalysis::UpdateElements(Elements* elements,Inputs* inputs,IoModel* iomodel,int analysis_counter,int analysis_type){/*{{{*/
 
 	bool   isefficientlayer;
@@ -98,23 +98,23 @@
 		if(iomodel->my_elements[i]){
 			Element* element=(Element*)elements->GetObjectByOffset(counter);
-			element->Update(inputs2,i,iomodel,analysis_counter,analysis_type,P1Enum);
+			element->Update(inputs,i,iomodel,analysis_counter,analysis_type,P1Enum);
 			counter++;
 		}
 	}
-	iomodel->FetchDataToInput(inputs2,elements,"md.geometry.thickness",ThicknessEnum);
-	iomodel->FetchDataToInput(inputs2,elements,"md.geometry.base",BaseEnum);
-	iomodel->FetchDataToInput(inputs2,elements,"md.mask.ice_levelset",MaskIceLevelsetEnum);
-	iomodel->FetchDataToInput(inputs2,elements,"md.basalforcings.groundedice_melting_rate",BasalforcingsGroundediceMeltingRateEnum);
-	iomodel->FetchDataToInput(inputs2,elements,"md.hydrology.basal_moulin_input",HydrologydcBasalMoulinInputEnum);
-	iomodel->FetchDataToInput(inputs2,elements,"md.initialization.sediment_head",SedimentHeadSubstepEnum);
-	iomodel->FetchDataToInput(inputs2,elements,"md.hydrology.sediment_transmitivity",HydrologydcSedimentTransmitivityEnum);
-	iomodel->FetchDataToInput(inputs2,elements,"md.hydrology.mask_thawed_node",HydrologydcMaskThawedNodeEnum);
+	iomodel->FetchDataToInput(inputs,elements,"md.geometry.thickness",ThicknessEnum);
+	iomodel->FetchDataToInput(inputs,elements,"md.geometry.base",BaseEnum);
+	iomodel->FetchDataToInput(inputs,elements,"md.mask.ice_levelset",MaskIceLevelsetEnum);
+	iomodel->FetchDataToInput(inputs,elements,"md.basalforcings.groundedice_melting_rate",BasalforcingsGroundediceMeltingRateEnum);
+	iomodel->FetchDataToInput(inputs,elements,"md.hydrology.basal_moulin_input",HydrologydcBasalMoulinInputEnum);
+	iomodel->FetchDataToInput(inputs,elements,"md.initialization.sediment_head",SedimentHeadSubstepEnum);
+	iomodel->FetchDataToInput(inputs,elements,"md.hydrology.sediment_transmitivity",HydrologydcSedimentTransmitivityEnum);
+	iomodel->FetchDataToInput(inputs,elements,"md.hydrology.mask_thawed_node",HydrologydcMaskThawedNodeEnum);
 	if(iomodel->domaintype!=Domain2DhorizontalEnum){
-		iomodel->FetchDataToInput(inputs2,elements,"md.mesh.vertexonbase",MeshVertexonbaseEnum);
-		iomodel->FetchDataToInput(inputs2,elements,"md.mesh.vertexonsurface",MeshVertexonsurfaceEnum);
+		iomodel->FetchDataToInput(inputs,elements,"md.mesh.vertexonbase",MeshVertexonbaseEnum);
+		iomodel->FetchDataToInput(inputs,elements,"md.mesh.vertexonsurface",MeshVertexonsurfaceEnum);
 	}
 	if(isefficientlayer){
-		iomodel->FetchDataToInput(inputs2,elements,"md.hydrology.mask_eplactive_node",HydrologydcMaskEplactiveNodeEnum);
-		iomodel->FetchDataToInput(inputs2,elements,"md.initialization.epl_head",EplHeadSubstepEnum);
+		iomodel->FetchDataToInput(inputs,elements,"md.hydrology.mask_eplactive_node",HydrologydcMaskEplactiveNodeEnum);
+		iomodel->FetchDataToInput(inputs,elements,"md.initialization.epl_head",EplHeadSubstepEnum);
 	}
 
@@ -205,5 +205,5 @@
 	}
 
-	basalelement->GetInput2Value(&thawed_element,HydrologydcMaskThawedEltEnum);
+	basalelement->GetInputValue(&thawed_element,HydrologydcMaskThawedEltEnum);
 
 	/*Check that all nodes are active, else return empty matrix*/
@@ -235,11 +235,11 @@
 	basalelement ->FindParam(&dt,TimesteppingTimeStepEnum);
 	basalelement ->FindParam(&isefficientlayer,HydrologydcIsefficientlayerEnum);
-	Input2* SedTrans_input = basalelement->GetInput2(HydrologydcSedimentTransmitivityEnum); _assert_(SedTrans_input);
-	Input2* sed_head_input = basalelement->GetInput2(SedimentHeadSubstepEnum);
-	Input2* base_input     = basalelement->GetInput2(BaseEnum);
+	Input* SedTrans_input = basalelement->GetInput(HydrologydcSedimentTransmitivityEnum); _assert_(SedTrans_input);
+	Input* sed_head_input = basalelement->GetInput(SedimentHeadSubstepEnum);
+	Input* base_input     = basalelement->GetInput(BaseEnum);
 
 	/*Transfer related Inputs*/
 	if(isefficientlayer){
-		basalelement->GetInput2Value(&active_element,HydrologydcMaskEplactiveEltEnum);
+		basalelement->GetInputValue(&active_element,HydrologydcMaskEplactiveEltEnum);
 	}
 	/* Start  looping on the number of gaussian points: */
@@ -308,5 +308,5 @@
 	}
 
-	basalelement->GetInput2Value(&thawed_element,HydrologydcMaskThawedEltEnum);
+	basalelement->GetInputValue(&thawed_element,HydrologydcMaskThawedEltEnum);
 
 	/*Check that all nodes are active, else return empty matrix*/
@@ -329,8 +329,8 @@
 
 	IssmDouble *xyz_list             = NULL;
-	Input2     *active_element_input = NULL;
-	Input2     *old_wh_input         = NULL;
-	Input2     *dummy_input          = NULL;
-	Input2     *surface_runoff_input = NULL;
+	Input     *active_element_input = NULL;
+	Input     *old_wh_input         = NULL;
+	Input     *dummy_input          = NULL;
+	Input     *surface_runoff_input = NULL;
 
 	/*Fetch number of nodes and dof for this finite element*/
@@ -347,12 +347,12 @@
 	basalelement->FindParam(&smb_model,SmbEnum);
 
-	Input2*	sed_head_input   = basalelement->GetInput2(SedimentHeadSubstepEnum);
-	Input2*	epl_head_input   = basalelement->GetInput2(EplHeadSubstepEnum);
-	Input2*	base_input       = basalelement->GetInput2(BaseEnum);
-	Input2*	basal_melt_input = basalelement->GetInput2(BasalforcingsGroundediceMeltingRateEnum); _assert_(basal_melt_input);
-	Input2*	SedTrans_input   = basalelement->GetInput2(HydrologydcSedimentTransmitivityEnum); _assert_(SedTrans_input);
+	Input*	sed_head_input   = basalelement->GetInput(SedimentHeadSubstepEnum);
+	Input*	epl_head_input   = basalelement->GetInput(EplHeadSubstepEnum);
+	Input*	base_input       = basalelement->GetInput(BaseEnum);
+	Input*	basal_melt_input = basalelement->GetInput(BasalforcingsGroundediceMeltingRateEnum); _assert_(basal_melt_input);
+	Input*	SedTrans_input   = basalelement->GetInput(HydrologydcSedimentTransmitivityEnum); _assert_(SedTrans_input);
 
 	if(dt!= 0.){
-		old_wh_input = basalelement->GetInput2(SedimentHeadOldEnum); _assert_(old_wh_input);
+		old_wh_input = basalelement->GetInput(SedimentHeadOldEnum); _assert_(old_wh_input);
 	}
 	if(smb_model==SMBgradientscomponentsEnum){
@@ -363,21 +363,21 @@
 		if(smbsubstepping==1){
 			//no substeping for the smb we take the result from there
-			dummy_input = basalelement->GetInput2(SmbRunoffEnum); _assert_(dummy_input);
+			dummy_input = basalelement->GetInput(SmbRunoffEnum); _assert_(dummy_input);
 		}
 		else if(smbsubstepping>1 && smbsubstepping<=hydrologysubstepping){
 			//finer hydro stepping, we take the value at the needed time
-			dummy_input = basalelement->GetInput2(SmbRunoffTransientEnum, time); _assert_(dummy_input);
+			dummy_input = basalelement->GetInput(SmbRunoffTransientEnum, time); _assert_(dummy_input);
 		}
 		else{
 			//finer stepping in smb, we average the runoff from transient input
 			basalelement->FindParam(&smb_averaging,SmbAveragingEnum);
-			dummy_input = basalelement->GetInput2(SmbRunoffTransientEnum,time-dt,time,smb_averaging); _assert_(dummy_input);
-		}
-		surface_runoff_input=xDynamicCast<Input2*>(dummy_input); _assert_(surface_runoff_input);
+			dummy_input = basalelement->GetInput(SmbRunoffTransientEnum,time-dt,time,smb_averaging); _assert_(dummy_input);
+		}
+		surface_runoff_input=xDynamicCast<Input*>(dummy_input); _assert_(surface_runoff_input);
 	}
 
 	/*Transfer related Inputs*/
 	if(isefficientlayer){
-		basalelement->GetInput2Value(&active_element,HydrologydcMaskEplactiveEltEnum);
+		basalelement->GetInputValue(&active_element,HydrologydcMaskEplactiveEltEnum);
 	}
 
@@ -528,7 +528,7 @@
 
 	/*Add input to the element: */
-	element->AddBasalInput2(SedimentHeadSubstepEnum,values,P1Enum);
-	element->AddBasalInput2(EffectivePressureSubstepEnum,pressure,P1Enum);
-	element->AddBasalInput2(SedimentHeadResidualEnum,residual,P1Enum);
+	element->AddBasalInput(SedimentHeadSubstepEnum,values,P1Enum);
+	element->AddBasalInput(EffectivePressureSubstepEnum,pressure,P1Enum);
+	element->AddBasalInput(SedimentHeadResidualEnum,residual,P1Enum);
 
 	/*Free ressources:*/
@@ -547,5 +547,5 @@
 }/*}}}*/
 /*Intermediaries*/
-IssmDouble HydrologyDCInefficientAnalysis::SedimentStoring(Element* element,Gauss* gauss,Input2* sed_head_input, Input2* base_input){/*{{{*/
+IssmDouble HydrologyDCInefficientAnalysis::SedimentStoring(Element* element,Gauss* gauss,Input* sed_head_input, Input* base_input){/*{{{*/
 	int unconf_scheme;
 	IssmDouble expfac;
@@ -577,5 +577,5 @@
 	return sediment_storing;
 }/*}}}*/
-IssmDouble HydrologyDCInefficientAnalysis::SedimentTransmitivity(Element* element,Gauss* gauss,Input2* sed_head_input, Input2* base_input,Input2* SedTrans_input){/*{{{*/
+IssmDouble HydrologyDCInefficientAnalysis::SedimentTransmitivity(Element* element,Gauss* gauss,Input* sed_head_input, Input* base_input,Input* SedTrans_input){/*{{{*/
 	int unconf_scheme;
 	IssmDouble sediment_transmitivity;
@@ -664,5 +664,5 @@
 	return transfer;
 }/*}}}*/
-IssmDouble HydrologyDCInefficientAnalysis::GetHydrologyPVectorTransfer(Element* element, Gauss* gauss, Input2* epl_head_input){/*{{{*/
+IssmDouble HydrologyDCInefficientAnalysis::GetHydrologyPVectorTransfer(Element* element, Gauss* gauss, Input* epl_head_input){/*{{{*/
 
 	int transfermethod;
@@ -696,5 +696,5 @@
 		element=xDynamicCast<Element*>(femmodel->elements->GetObjectByOffset(i));
 
-		Input2* input=element->GetInput2(HydrologydcMaskEplactiveNodeEnum); _assert_(input);
+		Input* input=element->GetInput(HydrologydcMaskEplactiveNodeEnum); _assert_(input);
 		if(input->GetInputMax()>0.){
 			element_active = true;
@@ -703,5 +703,5 @@
 			element_active = false;
 		}
-		element->SetBoolInput(element->inputs2,HydrologydcMaskEplactiveEltEnum,element_active);
+		element->SetBoolInput(element->inputs,HydrologydcMaskEplactiveEltEnum,element_active);
 	}
 }/*}}}*/
@@ -756,5 +756,5 @@
 		element=xDynamicCast<Element*>(femmodel->elements->GetObjectByOffset(i));
 
-		Input2* input=element->GetInput2(HydrologydcMaskThawedNodeEnum); _assert_(input);
+		Input* input=element->GetInput(HydrologydcMaskThawedNodeEnum); _assert_(input);
 		if(input->GetInputMax()>0.){
 			element_active = true;
@@ -763,5 +763,5 @@
 			element_active = false;
 		}
-		element->SetBoolInput(element->inputs2,HydrologydcMaskThawedEltEnum,element_active);
+		element->SetBoolInput(element->inputs,HydrologydcMaskThawedEltEnum,element_active);
 	}
 }/*}}}*/
@@ -791,5 +791,5 @@
 	/*Pass the activity mask from elements to nodes*/
 	basalelement->GetInputListOnVertices(&active[0],HydrologydcMaskThawedNodeEnum);
-	basalelement->GetInput2Value(&active_element,HydrologydcMaskThawedEltEnum);
+	basalelement->GetInputValue(&active_element,HydrologydcMaskThawedEltEnum);
 
 	for(int i=0;i<numnodes;i++) flag+=active[i];