Index: issm/trunk-jpl/test/NightlyRun/test252.py
===================================================================
--- issm/trunk-jpl/test/NightlyRun/test252.py	(revision 25398)
+++ issm/trunk-jpl/test/NightlyRun/test252.py	(revision 25709)
@@ -70,67 +70,69 @@
 md = solve(md, 'Transient')
 
-nlayers=np.size(md.results.TransientSolution[0].SmbT,1)
-for i in range(1, np.size(md.results.TransientSolution,0)):
-    nlayers=np.minimum(np.size(md.results.TransientSolution[i].SmbT,1),nlayers)
+nlayers = md.results.TransientSolution[0].SmbT.shape[1]
+for i in range(1, len(md.results.TransientSolution)):
+    nlayers=np.minimum(md.results.TransientSolution[i].SmbT.shape[1], nlayers)
 
 #Fields and tolerances to track changes
-
 field_names = ['Layers','SmbDz1', 'SmbT1', 'SmbD1', 'SmbRe1', 'SmbGdn1', 'SmbGsp1', 'SmbA1', 'SmbEC1', 'SmbMassBalance1', 'SmbMAdd1', 'SmbDzAdd1', 'SmbFAC1',
                'SmbDz2', 'SmbT2', 'SmbD2', 'SmbRe2', 'SmbGdn2', 'SmbGsp2', 'SmbA2', 'SmbEC2', 'SmbMassBalance2', 'SmbMAdd2', 'SmbDzAdd2', 'SmbFAC2',
                'SmbDz3', 'SmbT3', 'SmbD3', 'SmbRe3', 'SmbGdn3', 'SmbGsp3', 'SmbA3', 'SmbEC3', 'SmbMassBalance3', 'SmbMAdd3', 'SmbDzAdd3', 'SmbFAC3',
                'SmbDz4', 'SmbT4', 'SmbD4', 'SmbRe4', 'SmbGdn4', 'SmbGsp4', 'SmbA4', 'SmbEC4', 'SmbMassBalance4', 'SmbMAdd4', 'SmbDzAdd4', 'SmbFAC4']
-field_tolerances = [1e-12,1e-12,1e-12,1e-12,1e-12,1e-12,1e-12,1e-12,1e-12,1e-12,1e-12,1e-12,1e-12,
-                   1e-12,1e-12,1e-11,1e-10,2e-11,1e-11,1e-12,1e-11,1e-12,1e-12,1e-12,1e-11,
-                   1e-12,1e-12,2e-12,2e-11,4e-11,1e-11,1e-12,1e-11,1e-11,1e-12,1e-12,1e-11,
-                   1e-11,1e-11,4e-11,4e-11,1e-12,4e-11,1e-12,1e-12,1e-10,1e-12,1e-12,2e-11]
-
-
-#shape is different in python solution (fixed using reshape) which can cause test failure:
-field_values = [nlayers,md.results.TransientSolution[0].SmbDz[0, 0:nlayers].reshape(1, -1),
-                md.results.TransientSolution[0].SmbT[0, 0:nlayers].reshape(1, -1),
-                md.results.TransientSolution[0].SmbD[0, 0:nlayers].reshape(1, -1),
-                md.results.TransientSolution[0].SmbRe[0, 0:nlayers].reshape(1, -1),
-                md.results.TransientSolution[0].SmbGdn[0, 0:nlayers].reshape(1, -1),
-                md.results.TransientSolution[0].SmbGsp[0, 0:nlayers].reshape(1, -1),
-                md.results.TransientSolution[0].SmbA[0, 0:nlayers].reshape(1, -1),
-                md.results.TransientSolution[0].SmbEC[0],
-                md.results.TransientSolution[0].SmbMassBalance[0],
-                md.results.TransientSolution[0].SmbMAdd[0],
-                md.results.TransientSolution[0].SmbDzAdd[0],
-                md.results.TransientSolution[0].SmbFAC[0],
-                md.results.TransientSolution[145].SmbDz[0, 0:nlayers].reshape(1, -1),
-                md.results.TransientSolution[145].SmbT[0, 0:nlayers].reshape(1, -1),
-                md.results.TransientSolution[145].SmbD[0, 0:nlayers].reshape(1, -1),
-                md.results.TransientSolution[145].SmbRe[0, 0:nlayers].reshape(1, -1),
-                md.results.TransientSolution[145].SmbGdn[0, 0:nlayers].reshape(1, -1),
-                md.results.TransientSolution[145].SmbGsp[0, 0:nlayers].reshape(1, -1),
-                md.results.TransientSolution[145].SmbA[0, 0:nlayers].reshape(1, -1),
-                md.results.TransientSolution[145].SmbEC[0],
-                md.results.TransientSolution[145].SmbMassBalance[0],
-                md.results.TransientSolution[145].SmbMAdd[0],
-                md.results.TransientSolution[145].SmbDzAdd[0],
-                md.results.TransientSolution[145].SmbFAC[0],
-                md.results.TransientSolution[146].SmbDz[0, 0:nlayers].reshape(1, -1),
-                md.results.TransientSolution[146].SmbT[0, 0:nlayers].reshape(1, -1),
-                md.results.TransientSolution[146].SmbD[0, 0:nlayers].reshape(1, -1),
-                md.results.TransientSolution[146].SmbRe[0, 0:nlayers].reshape(1, -1),
-                md.results.TransientSolution[146].SmbGdn[0, 0:nlayers].reshape(1, -1),
-                md.results.TransientSolution[146].SmbGsp[0, 0:nlayers].reshape(1, -1),
-                md.results.TransientSolution[146].SmbA[0, 0:nlayers].reshape(1, -1),
-                md.results.TransientSolution[146].SmbEC[0],
-                md.results.TransientSolution[146].SmbMassBalance[0],
-                md.results.TransientSolution[146].SmbMAdd[0],
-                md.results.TransientSolution[146].SmbDzAdd[0],
-                md.results.TransientSolution[146].SmbFAC[0],
-                md.results.TransientSolution[-1].SmbDz[0, 0:nlayers].reshape(1, -1),
-                md.results.TransientSolution[-1].SmbT[0, 0:nlayers].reshape(1, -1),
-                md.results.TransientSolution[-1].SmbD[0, 0:nlayers].reshape(1, -1),
-                md.results.TransientSolution[-1].SmbRe[0, 0:nlayers].reshape(1, -1),
-                md.results.TransientSolution[-1].SmbGdn[0, 0:nlayers].reshape(1, -1),
-                md.results.TransientSolution[-1].SmbGsp[0, 0:nlayers].reshape(1, -1),
-                md.results.TransientSolution[-1].SmbA[0, 0:nlayers].reshape(1, -1),
-                md.results.TransientSolution[-1].SmbEC[0],
-                md.results.TransientSolution[-1].SmbMassBalance[0],
-                md.results.TransientSolution[-1].SmbMAdd[0],
-                md.results.TransientSolution[-1].SmbDzAdd[0],
-                md.results.TransientSolution[-1].SmbFAC[0]]
+field_tolerances = [
+    1e-12,1e-12,1e-12,1e-12,1e-12,1e-12,1e-12,1e-12,1e-12,1e-12,1e-12,1e-12,1e-12,
+    1e-12,1e-12,1e-11,1e-10,2e-11,1e-11,1e-12,1e-11,1e-12,1e-12,1e-12,1e-11,
+    1e-12,1e-12,2e-12,2e-11,4e-11,1e-11,1e-12,1e-11,1e-11,1e-12,1e-12,1e-11,
+    1e-11,1e-11,4e-11,4e-11,1e-12,4e-11,1e-12,1e-12,1e-10,1e-12,1e-12,2e-11
+]
+# Shape is different in python solution (fixed using reshape) which can cause test failure
+field_values = [
+    nlayers,
+    md.results.TransientSolution[0].SmbDz[0, 0:nlayers].reshape(1, -1),
+    md.results.TransientSolution[0].SmbT[0, 0:nlayers].reshape(1, -1),
+    md.results.TransientSolution[0].SmbD[0, 0:nlayers].reshape(1, -1),
+    md.results.TransientSolution[0].SmbRe[0, 0:nlayers].reshape(1, -1),
+    md.results.TransientSolution[0].SmbGdn[0, 0:nlayers].reshape(1, -1),
+    md.results.TransientSolution[0].SmbGsp[0, 0:nlayers].reshape(1, -1),
+    md.results.TransientSolution[0].SmbA[0, 0:nlayers].reshape(1, -1),
+    md.results.TransientSolution[0].SmbEC[0],
+    md.results.TransientSolution[0].SmbMassBalance[0],
+    md.results.TransientSolution[0].SmbMAdd[0],
+    md.results.TransientSolution[0].SmbDzAdd[0],
+    md.results.TransientSolution[0].SmbFAC[0],
+    md.results.TransientSolution[145].SmbDz[0, 0:nlayers].reshape(1, -1),
+    md.results.TransientSolution[145].SmbT[0, 0:nlayers].reshape(1, -1),
+    md.results.TransientSolution[145].SmbD[0, 0:nlayers].reshape(1, -1),
+    md.results.TransientSolution[145].SmbRe[0, 0:nlayers].reshape(1, -1),
+    md.results.TransientSolution[145].SmbGdn[0, 0:nlayers].reshape(1, -1),
+    md.results.TransientSolution[145].SmbGsp[0, 0:nlayers].reshape(1, -1),
+    md.results.TransientSolution[145].SmbA[0, 0:nlayers].reshape(1, -1),
+    md.results.TransientSolution[145].SmbEC[0],
+    md.results.TransientSolution[145].SmbMassBalance[0],
+    md.results.TransientSolution[145].SmbMAdd[0],
+    md.results.TransientSolution[145].SmbDzAdd[0],
+    md.results.TransientSolution[145].SmbFAC[0],
+    md.results.TransientSolution[146].SmbDz[0, 0:nlayers].reshape(1, -1),
+    md.results.TransientSolution[146].SmbT[0, 0:nlayers].reshape(1, -1),
+    md.results.TransientSolution[146].SmbD[0, 0:nlayers].reshape(1, -1),
+    md.results.TransientSolution[146].SmbRe[0, 0:nlayers].reshape(1, -1),
+    md.results.TransientSolution[146].SmbGdn[0, 0:nlayers].reshape(1, -1),
+    md.results.TransientSolution[146].SmbGsp[0, 0:nlayers].reshape(1, -1),
+    md.results.TransientSolution[146].SmbA[0, 0:nlayers].reshape(1, -1),
+    md.results.TransientSolution[146].SmbEC[0],
+    md.results.TransientSolution[146].SmbMassBalance[0],
+    md.results.TransientSolution[146].SmbMAdd[0],
+    md.results.TransientSolution[146].SmbDzAdd[0],
+    md.results.TransientSolution[146].SmbFAC[0],
+    md.results.TransientSolution[-1].SmbDz[0, 0:nlayers].reshape(1, -1),
+    md.results.TransientSolution[-1].SmbT[0, 0:nlayers].reshape(1, -1),
+    md.results.TransientSolution[-1].SmbD[0, 0:nlayers].reshape(1, -1),
+    md.results.TransientSolution[-1].SmbRe[0, 0:nlayers].reshape(1, -1),
+    md.results.TransientSolution[-1].SmbGdn[0, 0:nlayers].reshape(1, -1),
+    md.results.TransientSolution[-1].SmbGsp[0, 0:nlayers].reshape(1, -1),
+    md.results.TransientSolution[-1].SmbA[0, 0:nlayers].reshape(1, -1),
+    md.results.TransientSolution[-1].SmbEC[0],
+    md.results.TransientSolution[-1].SmbMassBalance[0],
+    md.results.TransientSolution[-1].SmbMAdd[0],
+    md.results.TransientSolution[-1].SmbDzAdd[0],
+    md.results.TransientSolution[-1].SmbFAC[0]
+]